'Should create end sub

'**************************************************************
' Created by Dean Zomar    zomar@shaw.ca
' As of: March 18, 2005     
' Version 2.03
' www.zomar.ca
'**************************************************************
 
'**************************************************************
' Create Date Folder
'**************************************************************
Dim FSO, Folder
yearnow = year(now)
monthnow = month(date)
If monthnow < 10 then monthnow= "0" & trim(monthnow)
daynow= Day(date)
If daynow< 10 then daynow= "0" & trim(daynow)
DateFolder = "_" & yearnow & monthnow & daynow & "\"

'**************************************************************
' Configuration Variables 
'**************************************************************
 'Backups are created in this location
 OutputFolder = "z:\!Copy\TestBackups\"
 
 'File name begining for the log file and the backup directory
 OutputFilePrefix = "Backup"
 
 'Copy these files to make backups of them
 InputFiles = "C:\Database\*.bmp"
	' InputFiles2 = "C:\Database\Cedarway\*.bmp"

'Minimum number of backup generations to keep
   MinBkupsToKeep = 3

'Minimum number of days to keep every backup generation
'If specifying zero, the script will not delete old generations created on the same
'day the script is run. A backup made today is considered zero days old and this
'field specifies the minimum age, in days, of backups that are to be kept.
   MinDaysToKeep = 2

'This is normally not changed but available for advanced use
 backupfolder = OutputFolder & OutputFilePrefix & DateFolder
	' backupfolder2 = OutputFolder & OutputFilePrefix & DateFolder & "Cedarway\"

'**************************************************************
' Common objects
'**************************************************************
 Set FSO = CreateObject("Scripting.FileSystemObject")
 Dim myNetworkObj
 Set myNetworkObj = Wscript.CreateObject("Wscript.Network")
 Dim TotalInputBytes   ' total size of all input folders
 TotalInputBytes = 0
 Set shellobj = CreateObject("Wscript.Shell")
 logfilename = OutputFolder & OutputFilePrefix & "_Log.txt"

'**************************************************************
' If folder already exists then exit script no changes are made
'************************************************************** 
If FSO.FolderExists(backupfolder) Then WScript.Quit
 
'**************************************************************
' Create log file and write out some environmental information
'**************************************************************
 Set logfileobj = FSO.createtextfile(logfilename,True)

 logfileobj.WriteLine "*** Backup script started at: " &now()& " ***"& VbCrLf
 logfileobj.WriteLine "Script: " & WScript.Scriptname &"  Version 2.11 "
 logfileobj.WriteLine "Environment:"
 Set WshSysEnv = Shellobj.Environment("SYSTEM")
 logfileobj.WriteLine "  OS: " &   WshSysEnv("OS") &_
                      "  Computer: " & myNetworkObj.ComputerName &_
                      "  User: " &  myNetworkObj.UserName &_
                      "  WSH version: " & WScript.Version
 set myNetworkObj = Nothing       ' let my object go
 Set WshSysEnv    = Nothing
 logfileobj.WriteLine "Running from: " & WScript.ScriptFullName &" by "& Wscript.Application
 logfileobj.WriteLine "Controlling parameters: MinBkupsToKeep="& MinBkupsToKeep & " MinDaysToKeep=" & MinDaysToKeep & VbCrLf

'**************************************************************
' Create remote folder & copy files
'**************************************************************
 logfileobj.writeline Now() & " Creating backup Folder " & backupfolder 
 FSO.CreateFolder(backupfolder)
 If FSO.FolderExists(backupfolder) Then
 logfileobj.writeline Now() & " Folder created successfully"
 Else
 logfileobj.writeline Now() & " Folder not created"
 logfileobj.writeline Now() & " Houston we have a problem exiting script"
 WScript.Quit
 End If 

 logfileobj.writeline Now() & " Starting copying files to backup folder"

 On Error Resume Next
 FSO.CopyFile InputFiles, backupfolder
 If Err.number <>0 Then
 logfileobj.writeline Now() & " *ERROR* " & Err.description & " for copy process"
 Err.clear
 On Error GoTo 0
 logfileobj.writeline Now() & " Deleting created folder and exiting script"
 Set MyFolder = fso.GetFolder(backupfolder)
 MyFolder.Delete
 WScript.Quit
 Else
 logfileobj.writeline Now() & " " & InputFiles & " have been copied to backup folder"
 Err.clear
 On Error GoTo 0
 End If
     
' FSO.CreateFolder(backupfolder2)
' FSO.CopyFile InputFiles2, backupfolder2

'**************************************************************
' Deal with backup generations
'**************************************************************
' Look for existing generations of backup folders
'--------------------------------------------------------------
  Dim outmsg3, BkupGenCount
  logfileobj.WriteLine vbCrLf&"Searching for existing backup folders . . . "
  logfileobj.WriteLine "  Looking in " & OutputFolder &_
                       " for directories starting with " & OutputFilePrefix
 
  BkupGenCount= 0                 'The number of backup generations found
  rootfold = OutputFolder         'Root folder from output folder object
  CountBackups(rootfold)          'Count the number of backup generations and log them

'**************************************************************
' Accumulate all the existing backup generations into an array
'**************************************************************
'This is done to aid in deleting the old generations
'Only do this in when there is more than one generation of backups
'Accumulate the array, then sort it by the age of the backup,
'  then skip the first MinBkupsToKeep generations of backup.
'On whatever is left, see if it is older than MinDaysToKeep days.
'If yes, it's the weakest link. Goodbye.
'--------------------------------------------------------------
   If BkupGenCount=0 Then
     logfileobj.WriteLine "Did not attempt to delete old backups because none were found."
  End If
  If (BkupGenCount=0) Then
        BkupGenCount = BkupGenCount   'A fudged no-op
  Else
   Dim BkupGenerations()
   ReDim BkupGenerations(BkupGenCount-1)
   AccumBkupGens(rootfold)   ' Build array of all the existing backup generations
  '                 The array BkupGenerations is now fully populated, but unsorted
  '                 Next up: sort it by the age of each backup generation                 
   If BkupGenCount > 1 Then    'only sort if the array has at least 2 elements
      Dim outer, inner
      For outer = 0 to BkupGenCount-2      'from first element to next-to-last element
      For inner= outer+1 To BkupGenCount-1 'end at last array element
        If BkupGenerations(inner) < BkupGenerations(outer) Then 'switch them
            temp = BkupGenerations(inner)
            BkupGenerations(inner) = BkupGenerations(outer)
            BkupGenerations(outer) = temp
        End If
      Next
      Next
   End If

'**************************************************************
'              Delete old backup generations
'**************************************************************
'Are there more backup generations than the minimum required?
'  If yes, start looking to prune them old backup generations
'BkupGenerations array is now sorted by the age of the backup 
' which is the  first 4 characters of each elements
'The newest backups are at the beginning of the array, 
' so simply skiping the first MinBkupsToKeep elements of the
'   array when looking to delete stuff will honor
'  the directive to keep that many generations no matter what
'The loop ends at the end of the BkupGenerations array
'The loop starts with generation MinBkupsToKeep plus one
'Force option to DeleteFolder command. It uses a boolean value
'  of True to indicate that force should be used.
'--------------------------------------------------------------
   If BkupGenCount > MinBkupsToKeep Then
      Dim indx, age4, forceit, DelCounter
      DelCounter = 0  'Count of deleted backup generations
      logfileobj.WriteLine "Examining old backups for possible deletion..."
      For indx = MinBkupsToKeep To BkupGenCount-1
        age4 = Left(BkupGenerations(indx),4) 'strip off the 4 digit age of bkup
        age4 = CLng(age4)                    'convert string to number (long)
        If age4 > MinDaysToKeep Then
           logfileobj.WriteLine "  Deleting " & Mid(BkupGenerations(indx),5) &_
                 " It is "& FormatNumber(age4,0) & " days old. Limit is " &_
                 MinDaysToKeep &" days"
           forceit = CBool(-1)  ' a TRUE boolean variable
           fso.DeleteFolder Mid(BkupGenerations(indx),5), forceit 'Delete backup folder
           DelCounter = DelCounter + 1   'Count of deleted backup generations
        End If
      Next
      logfileobj.WriteLine "Examination complete, "& DelCounter &" backup generations deleted."
   Else
      logfileobj.WriteLine "Did not attempt to delete old backups because minimum " &_
                           "generations not yet exceeded"
   End If
  End If
 
'*******************************************************************
' Loop thru the backups on the output disk drive a second time
'*******************************************************************
' Accumulate the backup generations in array BkupGenerations
' The array really should be two dimensional as it contains two data
'   items for each backup generation, the name and age. However, I
'   denormalized it into a single dimension array where each element
'   starts with a four digit age and is immediately followed by the
'   full name of the directory which contains the backup generation.
'   Its just easier to deal with this way, especially for sorting.
'   Sample array elements: 0012F:\somedir
'                          0002C:\otherdir
' Note: if there is ever a folder that is more than 9,999 days old
'   (27 years and change) this routine won't work correctly.
'--------------------------------------------------------------------
Sub AccumBkupGens(parm2)
  set thisFolder = FSO.GetFolder(parm2)  'folder object
  set subfoldcol = thisFolder.SubFolders 'subfolder collection
  dim ArrayIndex, age, PrefixLen
  ArrayIndex = 0
  PrefixLen = Len(OutputFilePrefix)
  For each onefolder in subfoldcol
    If Len(onefolder.name)>PrefixLen And Left(onefolder.name,PrefixLen)=OutputFilePrefix Then
       age = DateDiff("d",onefolder.DateCreated,Now)
       If Len(age) = 1 Then age = "000" & age
       If Len(age) = 2 Then age = "00"  & age
       If Len(age) = 3 Then age = "0"   & age
       BkupGenerations(ArrayIndex) = age&onefolder.path
       ArrayIndex = ArrayIndex + 1
    End If
  Next
  set thisFolder = Nothing
  Set subfoldcol = Nothing
end Sub

'*******************************************************************
' Count the number of backups that are on the output disk volume
' Pattern matched key is now a folder starting with OutputFilePrefix
' This is done to Dim the array where they will be stored
' Also, write the name, size and creation date to the log file
'-------------------------------------------------------------------
 Sub CountBackups(parm1)
     set thisFolder = FSO.GetFolder(parm1)
     set subfoldcol = thisFolder.SubFolders
     Dim PrefixLen
     PrefixLen = Len(OutputFilePrefix)
     For each onefolder in subfoldcol
       If Len(onefolder.name)>PrefixLen and Left(onefolder.name,PrefixLen)=OutputFilePrefix Then
          BkupGenCount= BkupGenCount+ 1
          logfileobj.WriteLine "  "& onefolder.path & " (" &_
                FormatNumber(onefolder.Size/1048576, 1)&" Meg) "&onefolder.DateCreated
       End If
     Next
     set thisFolder = Nothing
     set subfoldcol = Nothing
     logfileobj.WriteLine "Search completed"
 end Sub

'*******************************************************************
' release remaining objects
'*******************************************************************
Set FSO = Nothing
Set shellobj = Nothing
Set logfile = Nothing

'*******************************************************************
' Copy log to backup Folder and quit script
'*******************************************************************
Set filesys = CreateObject("Scripting.FileSystemObject")
filesys.CopyFile logfilename, backupfolder & "\"
Set filesys = Nothing
WScript.Quit